package edu.ucla.cs.dbevolution;

import it.polimi.elet.cautils.configurator.CAConfiguration;

import java.util.HashMap;


/**
 * Parameters for all the functionality of the application
 * Avoid every function to read the configuration file
 * @author fangar
 *
 */
public class ApplicationParameters {

	 //MYSQL PARAMETERS
	 private static String mysqlhost;
	 private static String mysqlport;
	 private static String dbbasename;
	 private static String dbbaseuri;
	 private static String user;
	 private static String pass;
	 private static String dbevolution;
	 
	 private static String repoType;
	 
	 //SVN PARAMETERS
	 private static String svnuser;
	 private static String svnpwd;
	 private static String svnurl;
	 private static String svnschemaurl;
	 
	 //CVS PARAMETERS
	 private static String cvsRoot;
	 private static String cvsmodule;
	 private static String cvsLocalPath;
	 private static String cvsSaveSchemaPath;
	 
	 
	 //APPLICATION PARAMETERS
	 private static HashMap<String,Boolean> functions = new HashMap<String, Boolean>();
	 private static String pathtoschema;
	 private static String cleaningType;
	 private static String statisticsFile; 
	 private static String collectionQuery;
	 private static HashMap<String,String> collectionTables = new HashMap<String, String>();
	 
	 //FILLING DB EVOLUTION PARAMETERS
	 private static String headerEvolutionTables;
	 private static String evolutionTable;
	 
	 
	 
	public static String getDbbaseuri() {
		return dbbaseuri;
	}
	
	public static void setDbbaseuri(String dbbaseuri) {
		ApplicationParameters.dbbaseuri = dbbaseuri;
	}
	

	//*****************************************//
	//		MYSQL PARAMETERS				  *//
	//*****************************************//
	
	public static void setMysqlhost(String mysqlhost) {
		ApplicationParameters.mysqlhost = mysqlhost;
	}
	public static String getMysqlhost() {
		return mysqlhost;
	}
	
	public static void setMysqlport(String mysqlport) {
		ApplicationParameters.mysqlport = mysqlport;
	}
	public static String getMysqlport() {
		return mysqlport;
	}
	
	public static String getDbbasename() {
		return dbbasename;
	}
	public static void setDbbasename(String dbbasename) {
		ApplicationParameters.dbbasename = dbbasename;
	}
	
	public static String getDbevolution() {
		return dbevolution;
	}
	public static void setDbevolution(String dbevolution) {
		ApplicationParameters.dbevolution = dbevolution;
	}
	
	public static String getUser() {
		return user;
	}
	
	public static void setUser(String user) {
		ApplicationParameters.user = user;
	}
	
	public static void setPass(String pass) {
		ApplicationParameters.pass = pass;
	}
	public static String getPass() {
		return pass;
	}
	
	
	//*****************************************//
	//		REPOSITORY PARAMETERS 			  *//
	//*****************************************//
	
	public static String getRepoType() {
		return repoType;
	}

	public static void setRepoType(String repoType) {
		ApplicationParameters.repoType = repoType;
	}
	
	//*****************************************//
	//		SVN PARAMETERS					  *//
	//*****************************************//
	
	public static void setSvnpwd(String svnpwd) {
		ApplicationParameters.svnpwd = svnpwd;
	}
	public static String getSvnpwd() {
		return svnpwd;
	}
	
	public static void setSvnuser(String svnuser) {
		ApplicationParameters.svnuser = svnuser;
	}
	public static String getSvnuser() {
		return svnuser;
	}
	
	public static String getSvnurl() {
		return svnurl;
	}
	public static void setSvnurl(String svnurl) {
		ApplicationParameters.svnurl = svnurl;
	}
	
	public static String getSvnschemaurl() {
		return svnschemaurl;
	}
	public static void setSvnschemaurl(String svnschemaurl) {
		ApplicationParameters.svnschemaurl = svnschemaurl;
	}
	
	
	//*******************************************//
	//		FUNCTION PARAMETERS					*//
	//*******************************************//
	
    public static void addParameter (String pName, Boolean pValue){
    	functions.put(pName, pValue);
    }
    
    public static Boolean getParameterValue (String pName){
    	return(functions.get(pName));
    }
	
	
	public static String getPathtoschema() {
		return pathtoschema;
	}
	
	public static void setPathtoschema(String pathtoschema) {
		ApplicationParameters.pathtoschema = pathtoschema;
	}

	
	//*****************************************//
	//		CVS PARAMETERS					  *//
	//*****************************************//
	
	public static String getCvsLocalPath() {
		return cvsLocalPath;
	}

	
	public static void setCvsLocalPath(String cvsLocalPath) {
		ApplicationParameters.cvsLocalPath = cvsLocalPath;
	}

	
	public static String getCvsmodule() {
		return cvsmodule;
	}

	
	public static void setCvsmodule(String cvsmodule) {
		ApplicationParameters.cvsmodule = cvsmodule;
	}

	
	public static String getCvsRoot() {
		return cvsRoot;
	}

	
	public static void setCvsRoot(String cvsRoot) {
		ApplicationParameters.cvsRoot = cvsRoot;
	}

	
	public static String getCvsSaveSchemaPath() {
		return cvsSaveSchemaPath;
	}

	
	public static void setCvsSaveSchemaPath(String cvsSaveSchemaPath) {
		ApplicationParameters.cvsSaveSchemaPath = cvsSaveSchemaPath;
	}

	
	public static HashMap<String, Boolean> getFunctions() {
		return functions;
	}

	
	public static void setFunctions(HashMap<String, Boolean> functions) {
		ApplicationParameters.functions = functions;
	}

	public static String getHeaderEvolutionTables() {
		return headerEvolutionTables;
	}

	public static void setHeaderEvolutionTables(String headerEvolutionTables) {
		ApplicationParameters.headerEvolutionTables = headerEvolutionTables;
	}

	public static String getCleaningType() {
		return cleaningType;
	}

	public static void setCleaningType(String cleaningType) {
		ApplicationParameters.cleaningType = cleaningType;
	}

	public static String getStatisticsFile() {
		return statisticsFile;
	}

	public static void setStatisticsFile(String statisticsFile) {
		ApplicationParameters.statisticsFile = statisticsFile;
	}

	public static String getCollectionQuery() {
		return collectionQuery;
	}

	public static void setCollectionQuery(String collectionQuery) {
		ApplicationParameters.collectionQuery = collectionQuery;
	}

	
	public static void addCollectionTable (String pName, String pValue){
	    	collectionTables.put(pName, pValue);
	}
	    
	public static String getCollectionColumn (String pName){
	   	return(collectionTables.get(pName));
	}

	public static HashMap<String, String> getCollectionTables() {
		return collectionTables;
	}

	public static void setCollectionTables(HashMap<String, String> collectionTables) {
		ApplicationParameters.collectionTables = collectionTables;
	}
	
	/**
	 * Load the application parameters from the configuration
	 * @param conf the application configuration
	 */
	public static void loadConfiguration(CAConfiguration conf){
		
		
		dbbaseuri = ((String) conf.getParameterValue("dburi"));	
		dbbasename = ((String) conf.getParameterValue("dbbasename"));
		user = ((String) conf.getParameterValue("user"));
		pass = ((String) conf.getParameterValue("pass"));
		dbevolution = ((String) conf.getParameterValue("dbevolution"));
		pathtoschema =((String) conf.getParameterValue("pathtoschema"));
		svnschemaurl = ((String) conf.getParameterValue("svnschemaurl"));
		addParameter("drop", Boolean.parseBoolean((String)conf.getParameterValue("drop")));
		addParameter("download", Boolean.parseBoolean((String)conf.getParameterValue("download")));
		addParameter("install", Boolean.parseBoolean((String)conf.getParameterValue("install")));
		addParameter("collect", Boolean.parseBoolean((String)conf.getParameterValue("collect")));
		addParameter("global", Boolean.parseBoolean((String)conf.getParameterValue("global")));
		addParameter("statistics", Boolean.parseBoolean((String)conf.getParameterValue("statistics")));
		repoType = ((String) conf.getParameterValue("repositoryType"));
		headerEvolutionTables = ((String) conf.getParameterValue("headerEvolutionTables"));
		evolutionTable = ((String) conf.getParameterValue("evolutionTable"));
		cleaningType = ((String) conf.getParameterValue("cleaningSchema"));
		statisticsFile = ((String)conf.getParameterValue("statisticsFile"));
		collectionQuery = ((String)conf.getParameterValue("queryfile"));
		svnurl = ((String) conf.getParameterValue("svnurl"));
		svnuser = ((String) conf.getParameterValue("svnuser"));
		svnpwd = ((String) conf.getParameterValue("svnpwd"));  
		cvsRoot = ((String) conf.getParameterValue("cvsRoot"));
		cvsLocalPath = ((String) conf.getParameterValue("cvsLocalPath"));
		cvsmodule = ((String) conf.getParameterValue("cvsModule"));
		cvsSaveSchemaPath = ((String) conf.getParameterValue("cvsSaveSchemaPath"));
	}

	public static void setEvolutionTable(String evolutionTable) {
		ApplicationParameters.evolutionTable = evolutionTable;
	}

	public static String getEvolutionTable() {
		return headerEvolutionTables + evolutionTable;
	}
	
	
}
