package edu.ucla.cs.dbevolution;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;
import java.util.Vector;

/**
 * 
 */

/**
 * @author krl
 *
 */
public class MysqlLogQueryExtractor {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		Vector<Query> q = null;
		try {
			q = extractQueryFromLog(new FileReader(args[0]));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		
		FileWriter fo;
		FileWriter fo2;
		try {
			fo = new FileWriter(args[1]);
			fo2 = new FileWriter(args[2]);
			for(int i = 0; i< q.size(); i++){		
				String str = "INSERT INTO wikimediaevolution.queries (query_text,comment,target_version) VALUES (\"" + removeBlanks(q.elementAt(i).getQuerytext()) + "\",\"" +  removeBlanks(q.elementAt(i).getComment()) + "\",\"25563\");";
				String str2 =  removeBlanks(q.elementAt(i).getQuerytext());
				
				fo.write(str);
				fo2.write(str2);
			}
			fo.close();
			fo2.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		
		
	}

	
	public static String removeBlanks(String s) {
		return removeTabs(removeSpaces(s));
	}
	public static String removeSpaces(String s) {
		  StringTokenizer st = new StringTokenizer(s," ",false);
		  String t="";
		  while (st.hasMoreElements()) t += st.nextElement() + " ";
		  return t;
	 }
	public static String removeTabs(String s) {
		  StringTokenizer st = new StringTokenizer(s,"\t",false);
		  String t="";
		  while (st.hasMoreElements()) t += st.nextElement() + " ";
		  return t;
	 }
	public static String removeNull(String s) {
		  StringTokenizer st = new StringTokenizer(s,"\0",false);
		  String t="";
		  while (st.hasMoreElements()) t += st.nextElement() + " ";
		  return t;
	 }
	
	public static String removeLineend(String s) {
		  StringTokenizer st = new StringTokenizer(s,"\n",false);
		  String t="";
		  while (st.hasMoreElements()) t += st.nextElement() + " ";
		  return t;
	 }	
	

	
	public static boolean cleanAndDump(String log_file, String cleanOutput_file){
		Vector<String> out;
		try {
			out = clean(new FileReader(log_file));
		} catch (FileNotFoundException e1) {
			return false;
		}
		
		String str = "";
		for(int i =0; i < out.size();i++)
			str = str + out.elementAt(i);

		
		FileWriter fo;
		try {
			fo = new FileWriter(cleanOutput_file);
			fo.write(str);
			fo.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return true;
	 
	}
	
	/**
	 * Read a mysql log file and extract the query from the log
	 * @param path to the file to read
	 * @return vector of query extracted from the log file
	 */
	public static Vector<Query> extractQueryFromLog(FileReader f){
		
		Vector<String> out = clean(f);
		Vector<Query> q = process(out);
		return q;	
	}

	// TODO: test this
	public static Vector<Query> extractQueryFromFile(FileReader f){
		String temp;
		Vector<Query> vout = new Vector();
		BufferedReader b = new BufferedReader(f);
		try {
		
			while(true){
				temp = b.readLine();
				if(temp!=null){
					vout.add(new Query(removeComment(temp),extractComment(temp)));
				}	
			}	
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		
		return vout;	
	}
	
	/**
	 * Extract the comment and the sql statement from log-record
	 * @param vector of query to process
	 * @return vector of cleaned query
	 */
	private static Vector<Query> process(Vector<String> in) {
		Vector<Query> vq  =new Vector();
		
		for(int i = 0; i<in.size();i++){
			vq.add(new Query(removeComment(in.elementAt(i)),extractComment(in.elementAt(i))));
		}
		return vq;	
	}

	/**
	 * Clean the log file from all useless record written by mysql
	 * @param path to the file to analyze
	 * @return vector of string query still containing the comment
	 */
	private static Vector<String> clean(FileReader f) {
		Vector<String> vout = new Vector();
		BufferedReader b = new BufferedReader(f);
		String temp = null;
		String out = "";
		//remove first 3 line
		try {
			b.readLine();
			b.readLine();
			b.readLine();
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		while(true){
	    try {
			String line = b.readLine();
			
			if(line == null)
				break;
			line.replace('\n', ' ');			
			if(line.indexOf("SET")>=0 || line.indexOf("Init DB")>=0 || line.indexOf("Quit")>=0 || line.indexOf("Connect") >= 0 || line.indexOf("BEGIN")>=0 || line.indexOf("COMMIT")>=0  ){
				if(temp!=null){
					temp = removeBlanks(temp);
					vout.add(new String(temp+"\n"));	
					temp=null;
				}
			}
			else{
				if(line.indexOf("Query") >= 0){
					if(temp!=null){
						temp = removeBlanks(temp);
						vout.add(new String(temp +"\n"));	
						temp=null;
					}
					temp = line.substring(line.indexOf("Query") + 5);	
				}
				else{
					temp = temp + line;
					// ADD HERE MULTIPLE SPACES REMOVE
				}	
			}

		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			break;
		}
		}
		return vout;
	}

	/**
	 * Remove the comment from the given line of the log
	 * @param temp
	 * @return
	 */
	private static String removeComment(String temp) {
			String mytemp = new String(temp);
			while(mytemp.indexOf("/*")>=0){
			int init = mytemp.indexOf("/*");
			int end = mytemp.indexOf("*/");
			mytemp = mytemp.substring(0,init) + mytemp.substring(end+2,mytemp.length());
		}
			System.out.print(mytemp);
			return mytemp;
		}	
	
	/**
	 * Extract the comment from the given line of the log
	 * @param temp String to be parsed
	 * @return
	 */
	private static String extractComment(String temp) {
		String mytemp = temp;
		String com ="";
		while(mytemp.indexOf("/*")>0){
		int init = mytemp.indexOf("/*");
		int end = mytemp.indexOf("*/");
		com = com + mytemp.substring(init + 2, end);
		mytemp = mytemp.substring(0,init) + mytemp.substring(end+2,mytemp.length());
	}
		return com;
	}	
}