package edu.ucla.cs.dbevolution;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.List;

/**
 * The class performs the operation of the bash script
 * Download databases from the svn, install the database, drop the database
 * @author fangar
 *
 */

public class ScriptOperation {

	
	public boolean CreateDb(){
		
		//String user =null;
		//String password = null;
		
		String createStm = "CREATE DATABASE IF NOT EXIST ";
		ResultSet rs = null;
		List<String> databases = null;
		
		System.out.println("CHECKING CONFIGURATION");
		if(ApplicationParameters.getMysqlhost() == null){
			System.out.println("mysqlhost must be set to continue");
			return false;
		}
		if(ApplicationParameters.getUser()==null){
			System.out.println("username must be set to continue");
			return false;
		}
		if(ApplicationParameters.getPass()==null){
			System.out.println("password must be set to continue");
			return false;
		}
		if(ApplicationParameters.getDbbasename()==null){
			System.out.println("dbbasename must be set to continue");
			return false;
		}
		//user = ApplicationParameters.getUser();
		//password = ApplicationParameters.getPass();
		
		//connect to the database and read all the version of the database to install
		//al this operation must be performed on the mysql database
		Connection conn = connect(ApplicationParameters.getDbbaseuri(),"wikimediaevolution",ApplicationParameters.getUser(),ApplicationParameters.getPass());
		Statement st = null;
		try {
			st = conn.createStatement();
		} catch (SQLException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		//get all the db downloaded
		try{
			rs = st.executeQuery("SELECT dbname FROM database");
			while(rs.next()){
				databases.add((String)rs.getString(0));
			}
			st.close();
			//create the database and install the schema for the corresponding db
			for(int i=0;i<databases.size();i++){
				st = conn.createStatement();
				//create the database
				st.execute(createStm+databases.get(i));
				//load and create the schema of the selected db
			}
		}
		catch (SQLException e) {
			// TODO: handle exception
		}
		return true;
	}
	
	
	private static Connection connect(String dbbaseurl,String dbname, String user, String pass ) {
		Connection conn = null;
		try {
		    conn = (Connection) DriverManager.getConnection(dbbaseurl+dbname,user,pass);
		    // Do something with the Connection

		} catch (SQLException ex) {
		    // handle any errors
		    System.out.println("SQLException: " + ex.getMessage());
		    System.out.println("SQLState: " + ex.getSQLState());
		    System.out.println("VendorError: " + ex.getErrorCode());
		}
		
		return conn;	
	}
	
	
	
}
