package edu.ucla.cs.statistics;

import java.util.Vector;

public class Savepoint {

	
	private int columnsCount;
	private Vector<String> columnsName;
	
	
	public Vector<String> getColumnsName() {
		return columnsName;
	}
	public void setColumnsName(Vector<String> columnsName) {
		this.columnsName = columnsName;
	}
	
	public int getColumnsCount() {
		return columnsCount;
	}
	public void setColumnsCount(int columnsCount) {
		this.columnsCount = columnsCount;
	}
	
	
	/**
	 * @param s
	 * @param savepoint
	 * @return
	 */
	public boolean compareSavepoints(Savepoint s, Savepoint savepoint){
		
		if(compareColumnsCount(s, savepoint) && compareColumnsName(s, savepoint)){
			return true;
		}
		return  false;
		
	}
	
	/**
	 * @param s
	 * @param savepoint
	 * @return
	 */
	private boolean compareColumnsCount(Savepoint s, Savepoint savepoint){
		if(s.getColumnsCount() == savepoint.getColumnsCount()){
			return true;
		}
		return  false;
		
	}
	
	
	/**
	 * @param s
	 * @param savepoint
	 * @return
	 */
	private boolean compareColumnsName(Savepoint s, Savepoint savepoint){
		
		if(getDifference(s.getColumnsName(),savepoint.getColumnsName()) ==0 && getDifference(savepoint.getColumnsName(),s.getColumnsName())==0){
			return true;
		}
		return  false;
	}
	
	/**
	 * Get the difference between the tables of two different revisions
	 * @param first the first revision to compare
	 * @param second the second revision to compare
	 * @return the number of tables different between the two revisions
	 */
	private int getDifference(Vector<String> first, Vector<String> second){
		
		int countDiff=0;
		for(String table: first){
			if(!second.contains(table)){
				countDiff++;
			}
		}
		return countDiff;
	}
	

	
	
}
