package edu.ucla.cs.statistics;

import it.polimi.elet.cautils.configurator.CAConfiguration;

import java.util.Iterator;
import java.util.Vector;

import edu.ucla.cs.dbevolution.ApplicationParameters;


public class StatisticsParameters {

	private static String statPagePath;

	private static String templateDir;
	private static String templateStatPage;
	private static String templateStatHome;
	
	private static String introPage;
	private static String groups;
	
	
	/* PARAMETERS RISK COEFFICIENT */
	
	private static double riskColumnsCount;
	private static double riskColumnsTypeChange;
	private static double riskRollbackCount;
	private static double riskPrimaryKeyChange;
	private static double riskForeignKeyChange;
	private static double riskIndexChange;
	
	/*								*/
	
	private static Vector<String> stats;
	
	private static String statList; 
	
	private static String pageExt = ".html";
	
	//**************************************//
	//	GETTERS AND SETTERS 				//
	//**************************************//
	
	
	public static String getStatPagePath() {
		return statPagePath  + ApplicationParameters.getDbbasename() + "Stat/";
	}
	public static void setStatPagePath(String pagePath) {
		statPagePath = pagePath;
	}
	
	public static String getStatImagePath() {
		return StatisticsParameters.getStatPagePath() + "images/";
	}
	
	public static String getStatCsvPath() {
		return StatisticsParameters.getStatPagePath() + "csv/";
	}

	public static Vector<String> getStats(){
		return stats;
	}
	
	public static void addStat(String stat){
		stats.add(stat);
	}
	
	public static String getTemplateStatPage() {
		return templateStatPage;
	}
	public static void setTemplateStatPage(String templateStatPage) {
		StatisticsParameters.templateStatPage = templateStatPage;
	}
	
	public static String getTemplateStatHome() {
		return templateStatHome;
	}
	public static void setTemplateStatHome(String templateStatHome) {
		StatisticsParameters.templateStatHome = templateStatHome;
	}
	public static String getStatList() {
		return statList;
	}
	public static void setStatList(String statList) {
		StatisticsParameters.statList = statList;
	}
	public static String getIntroPage() {
		return introPage;
	}
	public static void setIntroPage(String introPage) {
		StatisticsParameters.introPage = introPage;
	}
	
	public static String getGroups() {
		return groups;
	}
	public static void setGroups(String groupsPage) {
		StatisticsParameters.groups = groupsPage;
	}
	public static String getTemplateDir() {
		return templateDir;
	}
	public static void setTemplateDir(String templateDir) {
		StatisticsParameters.templateDir = templateDir;
	}
	
	public static String getPageExt() {
		return pageExt;
	}
	



	/**
	 * Load the statistics parameters from the configuration
	 * @param conf the statistics configuration
	 */
	public static void loadConfiguration(CAConfiguration confStatistics){
		
		 stats = new Vector<String>();
		
		//parse the statistics configuration file
		statPagePath = (String)confStatistics.getParameterValue("pathPage");
		templateDir = (String)confStatistics.getParameterValue("templateDir");
		templateStatPage = (String)confStatistics.getParameterValue("templateStatPage");
		templateStatHome = (String)confStatistics.getParameterValue("templateStatHome");
		statList = (String)confStatistics.getParameterValue("statisticsList");
		introPage = (String)confStatistics.getParameterValue("introPage");
		groups = (String)confStatistics.getParameterValue("groups");
		riskColumnsCount = Double.parseDouble( ( String )confStatistics.getParameterValue("columnsCount"));
		riskColumnsTypeChange = Double.parseDouble( ( String )confStatistics.getParameterValue("columnsTypeChange"));
		riskRollbackCount = Double.parseDouble( ( String )confStatistics.getParameterValue("rollbackCount"));
		riskPrimaryKeyChange = Double.parseDouble( ( String )confStatistics.getParameterValue("primaryKeyChanges"));
		riskIndexChange = Double.parseDouble( ( String )confStatistics.getParameterValue("indexChanges"));
		riskForeignKeyChange = Double.parseDouble( ( String )confStatistics.getParameterValue("foreignKeyChanges"));
		
		
		//THIS PART RELATED TO THE STATISTIC TO PERFORM HAS CHANGED
		//THE NEW METHOD IS PERFORMED BY READING THE XML CONFIGURATION FILE AND
		//ADDING THE STATISTICS TO PERFORM
		//read all the statistics to perform
		//iterator over the keyset, all the keys of the hashmap 
		/*Iterator itStatistics = confStatistics.keys();
		
		String statValue;
		String statParam;
		while(itStatistics.hasNext()){
			//print all the keys of the statistics file
			statParam = itStatistics.next().toString();
			if(statParam.startsWith("stat")){
				statValue = (String)confStatistics.getParameterValue(statParam); 
				if(statValue.equals("true")){
					//if the statiscs isn't already present in the configuration file
					if(stats.indexOf(statParam)==-1)
						addStat(statParam);	
				}
			}
		}*/		
	}
	
	
	
	public static double getRiskColumnsCount() {
		return riskColumnsCount;
	}
	public static void setRiskColumnsCount(double riskColumnsCount) {
		StatisticsParameters.riskColumnsCount = riskColumnsCount;
	}
	public static double getRiskColumnsTypeChange() {
		return riskColumnsTypeChange;
	}
	public static void setRiskColumnsTypeChange(double riskColumnsTypeChange) {
		StatisticsParameters.riskColumnsTypeChange = riskColumnsTypeChange;
	}
	public static double getRiskRollbackCount() {
		return riskRollbackCount;
	}
	public static void setRiskRollbackCount(double riskRollbackCount) {
		StatisticsParameters.riskRollbackCount = riskRollbackCount;
	}
	public static double getRiskPrimaryKeyChange() {
		return riskPrimaryKeyChange;
	}
	public static void setRiskPrimaryKeyChange(double riskPrimaryKeyChange) {
		StatisticsParameters.riskPrimaryKeyChange = riskPrimaryKeyChange;
	}
	public static double getRiskForeignKeyChange() {
		return riskForeignKeyChange;
	}
	public static void setRiskForeignKeyChange(double riskForeignKeyChange) {
		StatisticsParameters.riskForeignKeyChange = riskForeignKeyChange;
	}
	public static double getRiskIndexChange() {
		return riskIndexChange;
	}
	public static void setRiskIndexChange(double riskIndexChange) {
		StatisticsParameters.riskIndexChange = riskIndexChange;
	}
	
	
}
